__doc__ = """Z Photo Slides by JeanFranois Roche (jfroche@jfroche.be)"""

__version__='$Revision: 1.4 $'[11:-2]

from Globals import HTMLFile      # fakes a method from a DTML file
from Globals import HTML
from Globals import package_home
from Globals import MessageDialog # provid
from Globals import Persistent    # makes an object stick in the ZODB
from OFS.Folder import Folder
from OFS.Image	import Image
from AccessControl import ClassSecurityInfo

import OFS.SimpleItem
import Acquisition
import AccessControl.Role
import traceback
import os, sys
import math
import time
import shutil
import comment
import message_dialog

from Products.PageTemplates import ZopePageTemplate
from Products.LocalFS import LocalFS
#from Products.LocalFS.LocalDirectory import defaultDocument
#import Products.LocalFS
from Products.PythonScripts import PythonScript

from IMG_start import MakeThumbnails
from image_modif import Image_modif
from IMG_fileobj import FileObj

def upload_file(path,_prefix=None):
        if _prefix is None: _prefix=SOFTWARE_HOME
        elif type(_prefix) is not type(''):
            _prefix=package_home(_prefix)
        path = os.path.join(_prefix, path)

        file=open(path, 'rb')
        data=file.read()
        file.close()
	return data

manage_addZPhotoSlidesForm = HTMLFile('dtml/ZPhotoSlidesAdd', globals())

MessageDialog2 = HTML("""
<HTML>
<HEAD>
<TITLE><dtml-var title></TITLE>
<link rel="stylesheet" href="stylesheet.css" type="text/css" />
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<FORM ACTION="<dtml-var action>" METHOD="GET" <dtml-if
 target>TARGET="<dtml-var target>"</dtml-if>>
 <input type="hidden" name="id" value="<dtml-var id>">

<TABLE BORDER="0" WIDTH="100%" CELLPADDING="10">
<TR>
  <TD VALIGN="TOP">
  <BR>
  <CENTER><B><FONT SIZE="+6" COLOR="#77003B">!</FONT></B></CENTER>
  </TD>
  <TD VALIGN="TOP">
  <BR><BR>
  <CENTER>
  <dtml-var message>
  </CENTER>
  </TD>
</TR>
<TR>
  <TD VALIGN="TOP">
  </TD>
  <TD VALIGN="TOP">
  <CENTER>
  <INPUT TYPE="SUBMIT" VALUE="   Ok   ">
  </CENTER>
  </TD>
</TR>
</TABLE>
</FORM>
</BODY></HTML>""", target='', action='manage_main', title='Changed',id='')


def manage_addZPhotoSlides(self, id,photo_folder,thumb_prefix,scale,upload,title='',recursive=0,REQUEST=None):
    """Add a ZPhotoSlides to a folder."""
    # create localFS
    img = LocalFS.LocalFS('img','Local Images',photo_folder,username=None,password=None)

    #find the tmp dir
    for tmpdir in ('/tmp','c:\windows\Temp','c:\\'):
    	  	if os.path.isdir(tmpdir): break
    os.chdir(tmpdir)
    if(not os.path.isdir(os.path.join(tmpdir,'thumb'))): os.mkdir('thumb')
    tmpdir = os.path.join(tmpdir,'thumb')
    tmpwork = LocalFS.LocalFS('tmp','Local Temporary Folder',tmpdir,username=None,password=None)

    self._setObject(id, ZPhotoSlides(id,img,tmpwork,tmpdir,thumb_prefix,title))
    ZPS = self._getOb(id)
    ZPS._setObject('img', img)
    ZPS._setObject('tmp', tmpwork)
    # upload thumbnails
    ZPS.ask_4_thumbnails(prefix=thumb_prefix,scale=scale,upload=upload,REQUEST=None)
    ZPS.get_nbr_non_hidden_thumb()

    if (recursive == 1):
		recursive = -1
		ZPS.manage_addDTMLMethod('stylesheet.css', 'Stylesheet Template', upload_file('dtml/stylesheet.css', globals()), REQUEST=None)
#		ZPS.manage_addPageTemplate('index_html', title, upload_file('dtml/index_html.pt', globals()), REQUEST=None)
#		ZPS.manage_addPageTemplate('thumbnails_html', 'Thumbnails Template Site', upload_file('dtml/thumbnails_html.pt', globals()), REQUEST=None)
		ZPS._setObject('old_index', PythonScript.PythonScript('old_index'))
		ZPS.old_index.ZPythonScript_edit('compteur2=9', '')
		ZPS.old_index.write(upload_file('old_index.py',globals()))

		ZPS._setObject('batch_slides', PythonScript.PythonScript('batch_slides'))
		ZPS.batch_slides.write(upload_file('batch_slides.py',globals()))

		ZPS._setObject('view_photo', PythonScript.PythonScript('view_photo'))
		ZPS.view_photo.ZPythonScript_edit('id', '')
		ZPS.view_photo.write(upload_file('view_photo.py',globals()))

		ZPS._setObject('getcomment', PythonScript.PythonScript('getcomment'))
		ZPS.getcomment.ZPythonScript_edit('id', '')
		ZPS.getcomment.write(upload_file('getcomment.py',globals()))
		
		ZPS._setObject('index_html',PythonScript.PythonScript('index_html'))
		ZPS.index_html.ZPythonScript_edit('slide=0', '')
		ZPS.index_html.write(upload_file('new_index.py',globals()))
		ZPS._setObject('initials', PythonScript.PythonScript('initials'))
		ZPS.initials.write(upload_file('initials.py',globals()))
		#ZPS._setObject('batch_rows', PythonScript.PythonScript('batch_rows'))
		#ZPS.batch_rows.write(upload_file('batch_rows.py',globals()))
		ZPS._setObject('viewable_images', PythonScript.PythonScript('viewable_images'))
		ZPS.viewable_images.write(upload_file('viewable_images.py',globals()))

##    if (recursive):
## 	    	fo = FileObj(photo_folder)
## 		for i in fo.getDir():
##        		basename = os.path.basename(i)
##			try:
##				manage_addZPhotoSlides(ZPS,basename,i,thumb_prefix,scale,upload,basename,recursive,REQUEST=None)
##			except:
##	    			print 'Error in adding ZPhotoSlides'
##				for i in sys.exc_info(): print "%s" % (i)

    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


class ZPhotoSlides(
    Folder,
    ZopePageTemplate,
    OFS.SimpleItem.Item,   # A simple Principia object. Not Folderish.
#    Image,
    Persistent,            # Make us persistent. Yaah!
    Acquisition.Implicit,  # Uh, whatever.
    comment,comment.comments,
    AccessControl.Role.RoleManager # Security manager.
    ):

    security = ClassSecurityInfo()
    meta_type = 'ZPhotoSlides' # what do people think they're adding?

    manage_options = ( # what management options are there?
#	               {'label': 'Contents',       'action': 'manage_main'},
	               {'label': 'Properties',       'action': 'manage_props'},
		       {'label': 'View',       'action': 'index_html'}, # defaults to index_html
                       {'label': 'List all files', 'action': 'list_files'},
                       {'label': 'Make thumbnails', 'action': 'make_thumb'},
		       {'label': 'Manage photos', 'action': 'change_title'},
	               {'label': 'Security',   'action': 'manage_access'},


		     )

    __ac_permissions__=( # what permissions make sense for us?
		         ('View management screens', ('manage_tabs','manage_main')),
			 ('Change permissions',      ('manage_access',)           ),
		         ('Change ZPhotoSlides'     ,     ('manage_edit',)             ),
    #                     ('Manage photos' ,  ('manage_main',)      ),
#			 ('View ZPhotoSlides',       ('',)                        ),
		       )


    list_files = HTMLFile('dtml/List_files',globals())
    manage_props = HTMLFile('dtml/ZPhotoSlidesEdit', globals()) # Management Interface
    make_thumb = HTMLFile('dtml/make_thumb',globals()) # form for making the thumb
    edit_image = HTMLFile('dtml/edit_photo',globals())
    change_title = HTMLFile('dtml/list_title',globals())
 #   index_html2 = HTMLFile('dtml/Index',globals())
    add_comment = HTMLFile('dtml/add_comment',globals())
    list_comment = []
    security.declarePublic('index_html')
    security.declareProtected('View management screens','list_files','change_title','edit_image','make_thumb','manage_main','manage_props')

    def __init__(self, id,img,tmpwork,tmpdir,thumb_prefix,title=''):
        """initialise a new instance of ZPhotoSlides"""
        self.id = id
        self.title = title
	self.thumb_prefix = thumb_prefix
	self.image_folder = img
#	self.tmp = tmpwork
        self.color_fonts = 'blue'
	self.tmp_dir = tmpdir
        self.img_doc = img.defaultDocument()
        self.manage_addFolder('thumbnails', 'Thumbnails', createPublic=0, createUserF=0, REQUEST=None)
	self.thumbnails._setProperty('amount_photo',0)
#	self.manage_addFolder('comments', 'Comments', createPublic=0, createUserF=0, REQUEST=None)
	self.non_hidden_pic = 0
	self.list_non_hidden_pic = []
	self.rows = 3
	self.column = 3
	self.list_comment = []
	self.show_comment = 1
	self.show_viewed = 1
	#self.use_comment()

    def use_comment(self,id_photo,name,commt,place,email,REQUEST):
	"coooool"
	times = time.strftime('%H:%M:%S %d-%m-%Y', time.localtime())
	new = comment.comments(id_photo,commt,name,place,times,REQUEST.REMOTE_ADDR,email)
	self.list_comment.append(new)
	url = REQUEST.HTTP_REFERER
	url = url.split('?photo=')[1]
	list_param = {}
	list_param['id'] = url
	url_action = REQUEST.URL1
	url_action = url_action + '/view_photo'
	
	if REQUEST is not None:
            return MessageDialog2(
                title = 'Comment added',
                message = "Comment added for %s." % id_photo[3:],
                action = url_action,
		id = url,
                )
        
    def get_comment(self,id_photo):
	"cooooool"
	liste_dict = [] 
	for elem in self.list_comment:
#	    print elem.id
#	    print id
	    if(elem.id==id_photo):
#		    print 'poueeeeeeeeeeeeeet'
		    dict= {}
		    dict['comment'] =elem.commt
		    dict['user'] = elem.user
		    dict['place'] = elem.place
		    dict['date'] = elem.date
		    dict['ip'] = elem.ip
		    dict['email'] = elem.email
		    liste_dict.append(dict)	
	return liste_dict
		    
    def get_nbr_non_hidden_thumb(self):
	"cool"
	images = self.thumbnails.objectValues('Image')
	nbr= len(images)
	list_thumb = []
	for img in images:
		if(img.getviewit=='0'):
			nbr = nbr - 1
		else:
			list_thumb.append(img)
	self.non_hidden_pic = nbr
	self.list_non_hidden_pic = list_thumb
	return None

    def photo_visited(self,thumb_id):
	"""increase the number of visit of a photo"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	#print thumb_pic
        #thumb_pic._setProperty('viewed',int(thumb_pic.viewed) + 1)
	thumb_pic.viewed = int(thumb_pic.viewed) + 1
        return thumb_pic

    def getSlide(self,thumb_id):
	"""Give the number of the slide where is the photo"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos= thumb_pic.position
	tmp = pos/(self.rows*self.column)
	return tmp

    def photo_hasPrev(self,thumb_id):
	"""Give the previous photo of the list"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos = thumb_pic.position
	min = 99999999
	min_photo = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()!=thumb_id and pos > img.position and pos-int(img.position)<min):
		min = pos-int(img.position)
		min_photo = img.getId()
	if(min_photo == ''):
		return ''
	else:
		return min_photo

    def photo_hasNext(self,thumb_id):
	"""Give the next photo of the list"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos = thumb_pic.position
	min = 999999999
	min_photo = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()!=thumb_id and pos < img.position and int(img.position)-pos < min):
		min = pos-int(img.position)
		min_photo = img.getId()
	if(min_photo == ''):
		return ''
	else:
		return min_photo

    def manage_edit(self, title,show_comment,rows,column,photo_folder,color_fonts,show_viewed, REQUEST=None):
	"""does this really need a doc string?"""
	self.title = title
	old_basepath = self.image_folder.basepath
        self.image_folder.basepath = photo_folder
	self.color_fonts = color_fonts
	self.rows = int(rows)
	self.show_viewed = int(show_viewed)
	self.show_comment = int(show_comment)
	print self.show_comment
	self.column = int(column)
	if(old_basepath != photo_folder):
		self.remove_thumbnails()
        if REQUEST is not None:
            return MessageDialog(
                title = 'Edited',
                message = "Properties for %s changed." % self.id,
                action = './manage_main',
                )

    security.declarePrivate('remove_thumbnails')
    def remove_thumbnails(self):
	for img in self.thumbnails.objectValues('Image'):
		self.thumbnails.manage_delObjects(img.getId())
    
    security.declarePrivate('remove_thumbnails_from_disk')
    def remove_thumbnails_from_disk(self):
	for img in self.tmp.fileValues():
		tmpdir = os.path.join(self.tmp_dir,img.id)
		os.remove(tmpdir)
    
    security.declareProtected('View management screen','ask_4_thumbnails')
    def ask_4_thumbnails(self,prefix=None,scale=None,upload=None,REQUEST=None):
        """Make the thumbnails   from the path"""
	info = ''
	if prefix == None: prefix = REQUEST.prefix
        if scale == None: scale = REQUEST.scale
        if upload == None: upload = REQUEST.upload
	scale = int(scale)
#	print upload
	start_path = self.image_folder.basepath
        try:
           MakeThumbnails(start_path,self.tmp_dir,scale,prefix)
        except:
	    pass
#          print 'oooops' + ' ' +traceback.print_exc()
	result = 'Thumbnails done in folder %s' % self.tmp_dir
        if(upload=='1'):
	    info = self.upload_thumbnails()
	    result = result + '<br>Thumbnails uploaded in ZODB'
	    self.remove_thumbnails_from_disk()
	if (info != ''):
		result = result + '<br><center><b><font color="red">Error on files: %s</b></font></center>' %info
        if REQUEST is not None:
            return MessageDialog(
                title = 'Thumbnails',
                message = result,
                action = 'list_files' ,
                )
              
    security.declarePrivate('update_position')
    def update_position(self,new_position,old_position):
	for img in self.thumbnails.objectValues('Image'):
		if(img.position == new_position):
			img.position = old_position
				
    security.declareProtected('View management screen','update_photos_prop')
    def update_photos_prop(self,REQUEST):
        """cooo"""
	list = []
	for elem in REQUEST.items():
		if elem[0].find('stringbidon') != -1:
			list.append(elem)
	list2 = []
	dict = {}
	list3 = []
	for elem in list:
		full = elem[0].split('/')
		id = full[1]
		property = full[2]
		value = elem[1]
		for img in self.thumbnails.objectValues('Image'):
	                if(img.getId()==id):
			   if property == 'title':
				if(img.title != value):
	                	        img.title = value
					list3.append(id)
			   if property == 'viewit':
				if(img.getviewit != value):
					img.getviewit = value # property has change
					list3.append(id)
			   if property == 'position':
				old_position = img.position
				new_position = int(value)
        	                if(img.position != new_position):
					list3.append(id)
                	                self.update_position(new_position,old_position)
	                        	img.position = new_position
			   list2.append(img)
	string = ''
	for img in list3:
		cpt = 0
		for imgs in list3:
			if(img == imgs):
				cpt = cpt + 1
		if(cpt!=1):
			for cpt in range(cpt-1):
				list3.remove(img)
#	return list3
	for img in list3:
		string = string + ', ' + img
	self.get_nbr_non_hidden_thumb()
	string = string[1:]
	if(list3 != []):
		result = 'Properties of %s have been updated' % string
	else:
		result = 'Seems that you didnt change anything.'
	return MessageDialog(
		title = 'Change Properties',
		message = '%s.' % result,
		action = 'change_title',
		)

    security.declareProtected('View management screen','update_photo_prop')
    def update_photo_prop(self,REQUEST):
        """Update the title of a photo"""
	title = REQUEST.title
	id = REQUEST.id
	new_position = int(REQUEST.position)
	for img in self.thumbnails.objectValues('Image'):
		if(img.getId()==id):
			oldtitle = img.title
			img.title = title
			old_getviewit = img.getviewit
			old_position = img.position
			if(img.position != new_position):
				self.update_position(new_position,old_position)
			img.position = new_position
			img.getviewit = REQUEST.viewit
	if (oldtitle == title and old_getviewit == REQUEST.viewit and old_position == REQUEST.position):
		result = 'Seems that you didnt change anything of %s' % id
	else:
		result = 'Properties of %s has been updated' % id
        # FIX ME !!!!
	#return self.change_title(REQUEST=REQUEST)
        return MessageDialog(
                title = 'Change Title',
                message = "%s." % result,
                action = 'change_title' ,
                )
    security.declareProtected('View management screen','upload_thumbnails')
    def upload_thumbnails(self):
	"""Upload the thumbnails into the ZODB"""
#	print 'cooooooooooooooooooooooool'
	info = ''
	for img in self.tmp.fileValues():
		if(img.id[:len(self.thumb_prefix)]==self.thumb_prefix and img.id[-3:]!='bak'):
			 tmpdir = os.path.join(self.tmp_dir,img.id)
			 start_path = os.path.join(self.image_folder.basepath,img.id)
			 list = self.thumbnails.objectValues()
                         list2 = []
			 for elem in list:
				list2.append(elem.getId())
			 if img.id in list2:
	#			print 'already exist!!'
#				print self.thumbnails.objectValues()
				self.thumbnails.manage_delObjects(img.getId())
			 #data = str(img.getObject())
#			 print tmpdir
			 try:
				 file = open(tmpdir,'rb')
				 data = file.read()
				 file.close()
                                 type = OFS.Image.getImageInfo(data)
	                         self.thumbnails.manage_addImage(img.id,data,content_type=type[0])
			 except:
				 print 'error in uploading %s' % img.id
				 for i in sys.exc_info(): print "%s" % (i)
#		else:
#			print 'NON!!!!!!!!!!!!!'
	prop_id = 'getviewit'
	prop2_id = 'position'
	prop3_id = 'viewed'
        cpt = 0  
 	for imag in self.thumbnails.objectValues('Image'):
        #       	print imag.getId()
        	imag._setProperty(prop2_id.strip(),cpt)
		cpt = cpt + 1
 		imag._setProperty(prop_id.strip(), '1')
 		imag._setProperty(prop3_id.strip(), '0')
	self.thumbnails.amount_photo = cpt
	return info
	
    security.declareProtected('View management screen','image_modif')
    def image_modif(self,REQUEST):
        """Modify an image """
	image = REQUEST.file
        angle = REQUEST.angle
	path = self.image_folder.basepath
	abspath = path + '/' + image
	img = Image_modif(abspath)
        img.make_backup()
	modif = 0
	if(hasattr(REQUEST,'rotate') and REQUEST.rotate=='on'):	
		img.getrotate(angle)
		modif = 1
	if(hasattr(REQUEST,'grayscale') and REQUEST.grayscale=='on'):
		img.remove_color()
		modif = 1
	if(hasattr(REQUEST,'change_size') and REQUEST.change_size=='on'):
		modif = 1
		width = float(REQUEST.width)
		height = float(REQUEST.height)
		if(hasattr(REQUEST,'keep_ratio') and REQUEST.keep_ratio=='on'):
			oldheight = float(REQUEST.old_height)
			oldwidth = float(REQUEST.old_width)
			ratio = oldwidth/oldheight
			if(oldheight!=height and oldwidth==width): # height is modified
				width = ratio * height
			elif(oldheight==height and oldwidth!=width): # width is modified
			#	print ratio
			#	print ' coool '
				height = width/ratio
			#	print height
			elif(oldheight!=height and oldwidth!=width):
				width = ratio * height		
			img.resize_image(int(height),int(width),ratio)
		else:
			img.resize_image(height,width,0)
	if (modif==0):
	        return MessageDialog(
		        title = 'Image Modification',
			message =  'Nothing has to be done on image %s!' % image,
			action = 'list_files',
			)
	img.save_modif()
	if REQUEST is not None:
                return MessageDialog(
                 title = 'Image Modification',
                 message = "Modification for %s done." % image,
                 action = 'list_files' ,
                 )
    
    security.declareProtected('View management screen','get_image_info')
    def get_image_info(self,image_name):
	"""Get all the informations about an image"""
	path = self.image_folder.basepath
	abspath = os.path.join(path,image_name)
	img = Image_modif(abspath)
	dict = img.get_info()
	return dict

    security.declareProtected('View management screen','undo_modif')
    def undo_modif(self,REQUEST):
	"""Undo a previous modification of an image"""
	image = REQUEST.file
	bak = image + '.bak'
	path = self.image_folder.basepath
	new = os.path.join(path,image)
	backup = os.path.join(path,bak)
#	print backup
	if os.path.exists(backup):
	#    cmd = 'mv ' + backup + ' ' + new
	#    os.rename(backup,new)
	    shutil.copyfile(backup,new)
	    os.remove(backup)
#            os.popen(cmd)
            return MessageDialog(
                title = 'Undo',
                message = "Undo successfull !",
                action = 'list_files' ,
                )	
	else:
	    return MessageDialog(
                title = 'Undo',
                message = "Sorry, undo can't be done for this image.",
                action = 'list_files' ,
                )
                
    security.declareProtected('View management screen','notthumb')
    def notthumb(self,id):
	self.thumb_prefix_size = len(self.thumb_prefix)
	result = 1
	if(id[:self.thumb_prefix_size]==self.thumb_prefix):
		result = 0
	return result
	
    security.declarePublic('view_slides')
    def view_slides(self,REQUEST=None):
	"""print index_html"""
        try: 
	    return self.script_view(9)
	except:
	    print traceback.print_exc()

