# Jean-Franois Roche (jfroche@jfroche.be)
# ZPhotoSlides 0.3
# GNU GPL
# 


import os,sys
import PIL.Image
import PIL.ImageOps
import traceback
import shutil

class Image_modif:
	def __init__(self, path):
		fullpath = os.path.abspath(os.path.normpath(path))
                self.imgpath = fullpath
                try:
                        self.im = PIL.Image.open(self.imgpath)
                except:
			print traceback.print_exc()				
#                        sys.exit("Error : not a valid image file")
		self.imgname = os.path.basename(self.imgpath)
                self.basepath = os.path.dirname(self.imgpath)
                self.imgformat = self.im.format         # JPEG, GIF, ...
                self.imgmode = self.im.mode    
		self.rotname = self.imgname
	def make_backup(self):
                outputdir = self.basepath
                self.default = os.path.join(outputdir,self.rotname)
		backup = self.default + '.bak'
                try: # make a backup of the old photo before rotation
			shutil.copyfile(self.default,backup)
			
		except IOError, e:
                        return "Error on file %s : %s" % (self.imgpath,e)
	def get_info(self):
		format = self.im.format
		mode = self.im.mode
		size = self.im.size
		info = self.im.info
		dict = {'format': format,'mode': mode,'height':size[1],'width':size[0]}
		return dict

	def save_modif(self):
		try:
                        self.im.save(self.default)
                except IOError, e:
                        return "Error on file %s : %s" % (self.imgpath,e)
	def auto_contrast(self):
		PIL.ImageOps.autocontrast(self.im)
	def getrotate(self,angle):
                """rotate a photo with a given angle"""
                angle = int(angle)
		self.im = self.im.rotate(angle)

	def resize_image(self,height,width,ratio):
		assert height!=0.0,  'Height is 0! Impossible!'
		assert width!=0.0, 'Width is 0! Impossible!'
			
		photo_size = (width,height)
 		self.im = self.im.resize(photo_size)
		return self.im

	def remove_color(self):
		self.im = self.im.convert('L')

if __name__ == "__main__":
	a = Image_modif('/tmp/imgtest/MVC-383F.JPG')
#	a.get_info()
	a.make_backup()
#	a.resize_image(200,500)
#	a.remove_color()
	a.auto_contrast()
	a.save_modif()
